-- Test du paquetage P_Carac
-- Fichier carac.adb 
-- Ecrit le 22.4.96
-- Derniere mise a jour le 18.9.2001 

with Text_Io;
use Text_Io;

with Ada.Characters.Latin_1;
use Ada.Characters.Latin_1;

with P_Carac;
use P_Carac;

procedure Carac is 

   Fich_Out : File_Type;  

   C : Character;  

begin
   New_Line(2);
   Put_Line("Test du paquetage P_CARAC");
   New_Line;

   Put_Line("Fichier des resultats : CARAC.OUT");
   Create(Fich_Out, Out_File, "CARAC.OUT");
   Put_Line("Comparez vos resultats avec l'oracle : Fichier CARAC.ORA");
   New_Line;

   Put_Line(Fich_Out,"                       Fichier CARAC.OUT");
   Put_Line(Fich_Out,"                       *****************");
   New_Line(Fich_Out, 3);

   Put_Line(Fich_Out,
      "---------------- renames paquetage HANDLING -------------------");
   Put_Line(Fich_Out,
      "---------------------------------------------------------------");
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_CARAC_MAJUSCULE (C : in CHARACTER) return BOOLEAN;");
   Put_Line(Fich_Out, "           -------------------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "C=A => EST_CARAC_MAJUSCULE=" &
      Boolean'Image(Est_Carac_Majuscule('A')));
   Put_Line(Fich_Out, "C=a => EST_CARAC_MAJUSCULE=" &
      Boolean'Image(Est_Carac_Majuscule('a')));
   Put_Line(Fich_Out, "C=1 => EST_CARAC_MAJUSCULE=" &
      Boolean'Image(Est_Carac_Majuscule('1')));
   Put_Line(Fich_Out, "C=LATIN_1.UC_A_Grave => EST_CARAC_MAJUSCULE=" &
      Boolean'Image(Est_Carac_Majuscule(Uc_A_Grave)));
   Put_Line(Fich_Out, "C=LATIN_1.LC_A_Grave => EST_CARAC_MAJUSCULE=" &
      Boolean'Image(Est_Carac_Majuscule(Lc_A_Grave)));
   Put_Line(Fich_Out, "C=LATIN_1.LC_AE_Diphthong => EST_CARAC_MAJUSCULE=" &
      Boolean'Image(Est_Carac_Majuscule(Lc_Ae_Diphthong)));
   Put_Line(Fich_Out, "C=LATIN_1.LC_C_Cedilla => EST_CARAC_MAJUSCULE=" &
      Boolean'Image(Est_Carac_Majuscule(Lc_C_Cedilla)));
   New_Line(Fich_Out, 2);


   Put_Line(Fich_Out,
      "* function EST_CARAC_MINUSCULE (C : in CHARACTER) return BOOLEAN;");
   Put_Line(Fich_Out, "           -------------------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "C=A => EST_CARAC_MINUSCULE=" &
      Boolean'Image(Est_Carac_Minuscule('A')));
   Put_Line(Fich_Out, "C=a => EST_CARAC_MINUSCULE=" &
      Boolean'Image(Est_Carac_Minuscule('a')));
   Put_Line(Fich_Out, "C=1 => EST_CARAC_MINUSCULE=" &
      Boolean'Image(Est_Carac_Minuscule('1')));
   Put_Line(Fich_Out, "C=LATIN_1.UC_A_Grave => EST_CARAC_MINUSCULE=" &
      Boolean'Image(Est_Carac_Minuscule(Uc_A_Grave)));
   Put_Line(Fich_Out, "C=LATIN_1.LC_A_Grave => EST_CARAC_MINUSCULE=" &
      Boolean'Image(Est_Carac_Minuscule(Lc_A_Grave)));
   Put_Line(Fich_Out, "C=LATIN_1.LC_AE_Diphthong => EST_CARAC_MINUSCULE=" &
      Boolean'Image(Est_Carac_Minuscule(Lc_Ae_Diphthong)));
   Put_Line(Fich_Out, "C=LATIN_1.LC_C_Cedilla => EST_CARAC_MINUSCULE=" &
      Boolean'Image(Est_Carac_Minuscule(Lc_C_Cedilla)));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_CARAC_ALPHA (C : in CHARACTER) return BOOLEAN;");
   Put_Line(Fich_Out, "           ---------------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "C=A => EST_CARAC_ALPHA=" &
      Boolean'Image(Est_Carac_Alpha('A')));
   Put_Line(Fich_Out, "C=a => EST_CARAC_ALPHA=" &
      Boolean'Image(Est_Carac_Alpha('a')));
   Put_Line(Fich_Out, "C=1 => EST_CARAC_ALPHA=" &
      Boolean'Image(Est_Carac_Alpha('1')));
   Put_Line(Fich_Out, "C=+ => EST_CARAC_ALPHA=" &
      Boolean'Image(Est_Carac_Alpha('+')));
   Put_Line(Fich_Out, "C=LATIN_1.UC_A_Grave => EST_CARAC_ALPHA=" &
      Boolean'Image(Est_Carac_Alpha(Uc_A_Grave)));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "---------------------------------------------------------------");
   Put_Line(Fich_Out,
      "---------------------------------------------------------------");
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_CARAC_ESPACE (C : in CHARACTER) return BOOLEAN;");
   Put_Line(Fich_Out, "           ----------------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "C=A => EST_CARAC_ESPACE=" &
      Boolean'Image(Est_Carac_Espace('A')));
   Put_Line(Fich_Out, "C=espace => EST_CARAC_ESPACE=" &
      Boolean'Image(Est_Carac_Espace(' ')));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_CARAC_ALPHA_ESPACE (C : in CHARACTER) return BOOLEAN;");
   Put_Line(Fich_Out, "           ----------------------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "C=A => EST_CARAC_ALPHA_ESPACE=" &
      Boolean'Image(Est_Carac_Alpha_Espace('A')));
   Put_Line(Fich_Out, "C=Espace => EST_CARAC_ALPHA_ESPACE=" &
      Boolean'Image(Est_Carac_Alpha_Espace(' ')));
   Put_Line(Fich_Out, "C=1 => EST_CARAC_ALPHA_ESPACE=" &
      Boolean'Image(Est_Carac_Alpha_Espace('1')));
   Put_Line(Fich_Out, "C=LATIN_1.UC_A_Grave => EST_CARAC_ALPHA_ESPACE=" &
      Boolean'Image(Est_Carac_Alpha_Espace(Uc_A_Grave)));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_CARAC_ALPHANUM_ESPACE (C : in CHARACTER) return BOOLEAN;");
   Put_Line(Fich_Out, "           -------------------------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "C=A => EST_CARAC_ALPHANUM_ESPACE=" &
      Boolean'Image(Est_Carac_Alphanum_Espace('A')));
   Put_Line(Fich_Out, "C=Espace => EST_CARAC_ALPHANUM_ESPACE=" &
      Boolean'Image(Est_Carac_Alphanum_Espace(' ')));
   Put_Line(Fich_Out, "C=1 => EST_CARAC_ALPHANUM_ESPACE=" &
      Boolean'Image(Est_Carac_Alphanum_Espace('1')));
   Put_Line(Fich_Out, "C=LATIN_1.UC_A_Grave => EST_CARAC_ALPHANUM_ESPACE=" &
      Boolean'Image(Est_Carac_Alphanum_Espace(Uc_A_Grave)));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_CARAC_OPERATEUR(C : in CHARACTER) return BOOLEAN;");
   Put_Line(Fich_Out, "           -------------------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "C=A => EST_CARAC_OPERATEUR=" &
      Boolean'Image(Est_Carac_Operateur('A')));
   Put_Line(Fich_Out, "C=+ => EST_CARAC_OPERATEUR=" &
      Boolean'Image(Est_Carac_Operateur('+')));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_CARAC_SIGNE(C : in CHARACTER) return BOOLEAN;");
   Put_Line(Fich_Out, "           -------------------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "C=A => EST_CARAC_SIGNE=" &
      Boolean'Image(Est_Carac_Signe('A')));
   Put_Line(Fich_Out, "C=+ => EST_CARAC_SIGNE=" &
      Boolean'Image(Est_Carac_Signe('+')));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_CARAC_BINAIRE(C : in CHARACTER) return BOOLEAN;");
   Put_Line(Fich_Out, "           -----------------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "C=A => EST_CARAC_BINAIRE=" &
      Boolean'Image(Est_Carac_Binaire('A')));
   Put_Line(Fich_Out, "C=1 => EST_CARAC_BINAIRE=" &
      Boolean'Image(Est_Carac_Binaire('1')));
   Put_Line(Fich_Out, "C=0 => EST_CARAC_BINAIRE=" &
      Boolean'Image(Est_Carac_Binaire('0')));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_CARAC_SEPARATEUR(C : in CHARACTER) return BOOLEAN;");
   Put_Line(Fich_Out, "           --------------------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "C=A => EST_CARAC_SEPARATEUR=" &
      Boolean'Image(Est_Carac_Separateur('A')));
   Put_Line(Fich_Out, "C=. => EST_CARAC_SEPARATEUR=" &
      Boolean'Image(Est_Carac_Separateur('.')));
   Put_Line(Fich_Out, "C=/ => EST_CARAC_SEPARATEUR=" &
      Boolean'Image(Est_Carac_Separateur('/')));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* procedure TRANS_CARAC_MAJUSCULE (C : in out CHARACTER);");
   Put_Line(Fich_Out, "            ---------------------");
   Put_Line(Fich_Out, "La fonction est testee en meme temps");
   New_Line(Fich_Out);
   C:= 'A';
   Trans_Carac_Majuscule(C);
   Put_Line(Fich_Out, "C=A => C=" & C);
   C:= 'a';
   Trans_Carac_Majuscule(C);
   Put_Line(Fich_Out, "C=a => C=" & C);
   C:= '1';
   Trans_Carac_Majuscule(C);
   Put_Line(Fich_Out, "C=1 => C=" & C);
   C:= Uc_A_Grave;
   Trans_Carac_Majuscule(C);
   Put_Line(Fich_Out, "C=LATIN_1.UC_A_Grave => C=" & C);
   C:= Lc_A_Grave;
   Trans_Carac_Majuscule(C);
   Put_Line(Fich_Out, "C=LATIN_1.LC_A_Grave => C=" & C);
   C:= Lc_Ae_Diphthong;
   Trans_Carac_Majuscule(C);
   Put_Line(Fich_Out, "C=LATIN_1.LC_AE_Diphthong => C=" & C);
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* procedure TRANS_CARAC_MINUSCULE (C : in out CHARACTER);");
   Put_Line(Fich_Out, "            ---------------------");
   Put_Line(Fich_Out, "La fonction est testee en meme temps");
   New_Line(Fich_Out);
   C:= 'A';
   Trans_Carac_Minuscule(C);
   Put_Line(Fich_Out, "C=A => C=" & C);
   C:= 'a';
   Trans_Carac_Minuscule(C);
   Put_Line(Fich_Out, "C=a => C=" & C);
   C:= '1';
   Trans_Carac_Minuscule(C);
   Put_Line(Fich_Out, "C=1 => C=" & C);
   C:= Uc_A_Grave;
   Trans_Carac_Minuscule(C);
   Put_Line(Fich_Out, "C=LATIN_1.UC_A_Grave => C=" & C);
   C:= Lc_A_Grave;
   Trans_Carac_Minuscule(C);
   Put_Line(Fich_Out, "C=LATIN_1.LC_A_Grave => C=" & C);
   C:= Lc_Ae_Diphthong;
   Trans_Carac_Minuscule(C);
   Put_Line(Fich_Out, "C=LATIN_1.LC_AE_Diphthong => C=" & C);
   New_Line(Fich_Out, 2);

   Close(Fich_Out);

exception
   when others =>
      Close(Fich_Out);

end Carac;
