-- Test du paquetage P_ENTIER
-- Fichier : entier.adb 
-- Auteur : P. SEBILO
-- Ecrit le 23.4.96
-- Derniere mise a jour le 9.10.2001 

with Text_Io;
use Text_Io;

with P_Entier;
use P_Entier;

procedure Entier is 

   package Entier_Io is new Text_Io.Integer_Io(T_Entier);
   use Entier_Io;

   Fich_Out : File_Type;  

   A,  
   B      : T_Entier;  
   Maxi,  
   Median,  
   Mini   : T_Entier;  

begin
   New_Line(2);
   Put_Line("Test du paquetage P_ENTIER");
   New_Line(2);

   Put_Line("Fichier des resultats : ENTIER.OUT");
   Put_Line("Comparez les resultats avec l'oracle : fichier ENTIER.ORA");
   Create(Fich_Out, Out_File, "ENTIER.OUT");
   New_Line;

   Put_Line(Fich_Out,"                             Fichier ENTIER.OUT");
   Put_Line(Fich_Out,"                             ******************");
   New_Line(Fich_Out, 3);


   Put_Line(Fich_Out,
      "* function EST_NATUREL(A : in T_ENTIER) return BOOLEAN;");
   Put_Line(Fich_Out, "           -----------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "A=0 => EST_NATUREL=" & Boolean'Image(Est_Naturel(0)));
   Put_Line(Fich_Out, "A=-1 => EST_NATUREL=" & Boolean'Image(Est_Naturel(-
            1)));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_POSITIF(A : in T_ENTIER) return BOOLEAN;");
   Put_Line(Fich_Out, "           -----------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "A=0 => EST_POSITIF=" & Boolean'Image(Est_Positif(0)));
   Put_Line(Fich_Out, "A=-1 => EST_POSITIF=" & Boolean'Image(Est_Positif(-
            1)));
   Put_Line(Fich_Out, "A=1 => EST_POSITIF=" & Boolean'Image(Est_Positif(1)));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_PAIR (A : in T_ENTIER) return BOOLEAN;");
   Put_Line(Fich_Out, "           --------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "A=0 => EST_PAIR=" &
      Boolean'Image(Est_Pair(0)));
   Put_Line(Fich_Out, "A=1 => EST_PAIR=" &
      Boolean'Image(Est_Pair(1)));
   Put_Line(Fich_Out, "A=2 => EST_PAIR=" &
      Boolean'Image(Est_Pair(2)));
   Put_Line(Fich_Out, "A=-1 => EST_PAIR=" &
      Boolean'Image(Est_Pair(-1)));
   Put_Line(Fich_Out, "A=-2 => EST_PAIR=" &
      Boolean'Image(Est_Pair(-2)));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function EST_IMPAIR (A : in T_ENTIER) return BOOLEAN;");
   Put_Line(Fich_Out, "           ----------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "A=0 => EST_IMPAIR=" &
      Boolean'Image(Est_Impair(0)));
   Put_Line(Fich_Out, "A=1 => EST_IMPAIR=" &
      Boolean'Image(Est_Impair(1)));
   Put_Line(Fich_Out, "A=2 => EST_IMPAIR=" &
      Boolean'Image(Est_Impair(2)));
   Put_Line(Fich_Out, "A=-1 => EST_IMPAIR=" &
      Boolean'Image(Est_Impair(-1)));
   Put_Line(Fich_Out, "A=-2 => EST_IMPAIR=" &
      Boolean'Image(Est_Impair(-2)));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function MAXIMUM (A, B : in T_ENTIER) return T_ENTIER;");
   Put_Line(Fich_Out, "           -------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "A=1, B=2 => MAXIMUM=" & T_Entier'Image(Maximum(1, 2)));
   Put_Line(Fich_Out, "A=2, B=1 => MAXIMUM=" & T_Entier'Image(Maximum(2, 1)));
   Put_Line(Fich_Out, "A=1, B=1 => MAXIMUM=" & T_Entier'Image(Maximum(1, 1)));
   New_Line(Fich_Out, 2);

   Put_Line(Fich_Out,
      "* function MINIMUM (A, B : in T_ENTIER) return T_ENTIER;");
   Put_Line(Fich_Out, "           -------");
   New_Line(Fich_Out);
   Put_Line(Fich_Out, "A=1, B=2 => MINIMUM=" & T_Entier'Image(Minimum(1, 2)));
   Put_Line(Fich_Out, "A=2, B=1 => MINIMUM=" & T_Entier'Image(Minimum(2, 1)));
   Put_Line(Fich_Out, "A=1, B=1 => MINIMUM=" & T_Entier'Image(Minimum(1, 1)));
   New_Line(Fich_Out, 2);


   Put_Line(Fich_Out, "* procedure ECHANGER (A, B : in out T_ENTIER);");
   Put_Line(Fich_Out, "            --------");
   New_Line(Fich_Out);
   A:= 1;
   B:= 2;
   Echanger(A, B);
   Put_Line(Fich_Out, "A=1, B=2 => A=" & T_Entier'Image(A) &
      " B=" & T_Entier'Image(B));
   New_Line(Fich_Out, 2);


   Put_Line(Fich_Out,
      "* procedure TRIER (A, B : in T_ENTIER; MAXI, MINI: out T_ENTIER);");
   Put_Line(Fich_Out, "            -----");
   New_Line(Fich_Out);
   Trier(1, 1, Maxi, Mini);
   Put_Line(Fich_Out, "A=1, B=1 => MAXI=" & T_Entier'Image(Maxi) &
      " MINI=" & T_Entier'Image(Mini));
   Trier(1, 2, Maxi, Mini);
   Put_Line(Fich_Out, "A=1, B=2 => MAXI=" & T_Entier'Image(Maxi) &
      " MINI=" & T_Entier'Image(Mini));
   Trier(2, 1, Maxi, Mini);
   Put_Line(Fich_Out, "A=2, B=1 => MAXI=" & T_Entier'Image(Maxi) &
      " MINI=" & T_Entier'Image(Mini));
   Trier(1, 1, Maxi, Mini);
   Put_Line(Fich_Out, "A=1, B=1 => MAXI=" & T_Entier'Image(Maxi) &
      " MINI=" & T_Entier'Image(Mini));
   New_Line(Fich_Out, 2);


   Put_Line(Fich_Out,
      "* procedure TRIER (A, B, C : in T_ENTIER; MAXI, MEDIAN, MINI: out T_ENTIER);");
   Put_Line(Fich_Out, "            -----");
   New_Line(Fich_Out);
   Trier(1, 1, 1, Maxi, Median, Mini);
   Put_Line(Fich_Out, "A=1, B=1, C=1 => MAXI=" & T_Entier'Image(Maxi) &
      " MEDIAN=" & T_Entier'Image(Median) & " MINI=" & T_Entier'Image(
         Mini));
   Trier(1, 2, 3, Maxi, Median, Mini);
   Put_Line(Fich_Out, "A=1, B=2, C=3 => MAXI=" & T_Entier'Image(Maxi) &
      " MEDIAN=" & T_Entier'Image(Median) & " MINI=" & T_Entier'Image(
         Mini));
   Trier(1, 3, 2, Maxi, Median, Mini);
   Put_Line(Fich_Out, "A=1, B=3, C=2 => MAXI=" & T_Entier'Image(Maxi) &
      " MEDIAN=" & T_Entier'Image(Median) & " MINI=" & T_Entier'Image(
         Mini));
   Trier(2, 1, 3, Maxi, Median, Mini);
   Put_Line(Fich_Out, "A=2, B=1, C=3 => MAXI=" & T_Entier'Image(Maxi) &
      " MEDIAN=" & T_Entier'Image(Median) & " MINI=" & T_Entier'Image(
         Mini));
   Trier(2, 3, 1, Maxi, Median, Mini);
   Put_Line(Fich_Out, "A=2, B=3, C=1 => MAXI=" & T_Entier'Image(Maxi) &
      " MEDIAN=" & T_Entier'Image(Median) & " MINI=" & T_Entier'Image(
         Mini));
   Trier(3, 1, 2, Maxi, Median, Mini);
   Put_Line(Fich_Out, "A=3, B=1, C=2 => MAXI=" & T_Entier'Image(Maxi) &
      " MEDIAN=" & T_Entier'Image(Median) & " MINI=" & T_Entier'Image(
         Mini));
   Trier(3, 2, 1, Maxi, Median, Mini);
   Put_Line(Fich_Out, "A=3, B=2, C=1 => MAXI=" & T_Entier'Image(Maxi) &
      " MEDIAN=" & T_Entier'Image(Median) & " MINI=" & T_Entier'Image(
         Mini));
   New_Line(Fich_Out, 2);


   Close(Fich_Out);

end Entier;
