-- Paquetage complet de gestion du type Character
--   Utilise le paquetage Handling 
-- Fichier p_carac.adb 
-- Ecrit par P. SEBILO le 20.5.98
-- Dernire mise a jour le 13.12.99 

with Ada.Characters.Handling;
use Ada.Characters.Handling;

package body P_Carac is

   function Est_Carac_Espace (
         C : in     Character ) 
     return Boolean is 
   begin
      return C=' ';
   end Est_Carac_Espace;

   function Est_Carac_Alpha_Espace (
         C : in     Character ) 
     return Boolean is 
   begin
      return Est_Carac_Alpha(C) or Est_Carac_Espace(C);
   end;

   function Est_Carac_Alphanum_Espace (
         C : in     Character ) 
     return Boolean is 
   begin
      return Est_Carac_Alphanum(C) or Est_Carac_Espace(C);
   end Est_Carac_Alphanum_Espace;

   function Est_Carac_Operateur (
         C : in     Character ) 
     return Boolean is 
   begin
      return (C='+') or (C='-') or (C='*') or (C='/');
   end Est_Carac_Operateur;

   function Est_Carac_Signe (
         C : in     Character ) 
     return Boolean is 
   begin
      return (C='+') or (C='-');
   end Est_Carac_Signe;

   function Est_Carac_Binaire (
         C : in     Character ) 
     return Boolean is 
   begin
      return (C='0') or (C='1');
   end Est_Carac_Binaire;

   function Est_Carac_Separateur (
         C : in     Character ) 
     return Boolean is 
   begin
      return (C=' ') or (C=',') or (C=';') or (C='.') or (C=':') or
         (C='/') or (C='*') or (C='-') or (C='_');
   end Est_Carac_Separateur;

   -------------------------------

   procedure Trans_Carac_Majuscule (
         C : in out Character ) is 
   begin
      C:= Carac_Majuscule(C);
   end Trans_Carac_Majuscule;

   procedure Trans_Carac_Minuscule (
         C : in out Character ) is 
   begin
      C:= Carac_Minuscule(C);
   end Trans_Carac_Minuscule;

end P_Carac;
