-- Paquetage de gestion du type T_ENTIER 
-- Fichier p_entier.adb 
-- Ecrit par P. SEBILO le 29.3.96
-- Dernire mise  jour le 15.10.2002 

with P_E_Sortie;
use P_E_Sortie;

package body P_Entier is

   procedure Lire (
         L_Invite : in     String;  
         L_Entier :    out T_Entier ) is 
      Chaine : String (1 .. T_Entier'Width);  
   begin
      loop
         begin
            Ecrire(L_Invite & " : ");
            Lire(Chaine);
            L_Entier:= T_Entier'Value(Chaine);
            exit;
         exception
            when others =>
               null;
         end;
      end loop;
   end Lire;

   procedure Lire (
         L_Invite  : in     String;   
         L_Entier  :    out T_Entier; 
         Borne_Inf,                   
         Borne_Sup : in     T_Entier  ) is 
      Chaine : String (1 .. T_Entier'Width);  
   begin
      loop
         begin
            Ecrire(L_Invite & " (" & T_Entier'Image(Borne_Inf) & " .." &
               T_Entier'Image(Borne_Sup) & ") : ");
            Lire(Chaine);
            L_Entier:= T_Entier'Value(Chaine);
            if L_Entier in Borne_Inf..Borne_Sup
                  then
               exit;
            end if;
         exception
            when others =>
               null;
         end;
      end loop;
   end Lire;

   procedure Ecrire (
         L_Entier : in     T_Entier ) is 
   begin
      Ecrire(T_Entier'Image(L_Entier));
   end Ecrire;

   function Est_Naturel (
         A : in     T_Entier ) 
     return Boolean is 
   begin
      return A in T_Naturel;
   end Est_Naturel;

   function Est_Positif (
         A : in     T_Entier ) 
     return Boolean is 
   begin
      return A in T_Positif;
   end Est_Positif;

   function Est_Pair (
         A : in     T_Entier ) 
     return Boolean is 
   begin
      return A rem 2 = 0;
   end Est_Pair;

   function Est_Impair (
         A : in     T_Entier ) 
     return Boolean is 
   begin
      return A rem 2 /= 0;
   end Est_Impair;

   procedure Echanger (
         A,                  
         B : in out T_Entier ) is 
      Aux : T_Entier;  
   begin
      Aux:= A;
      A:= B;
      B:= Aux;
   end Echanger;

   procedure Trier (
         A,                      
         B    : in     T_Entier; 
         Maxi,                   
         Mini :    out T_Entier  ) is 
   begin
      Maxi:= T_Entier'Max(A, B);
      Mini:= T_Entier'Min(A, B);
   end Trier;

   procedure Trier (
         A,                        
         B,                        
         C      : in     T_Entier; 
         Maxi,                     
         Median,                   
         Mini   :    out T_Entier  ) is 
      Aux1,  
      Aux2 : T_Entier;  
   begin
      Trier(A, B, Aux1, Aux2);
      if C > Aux1
            then
         Maxi:= C;
         Median:= Aux1;
         Mini:= Aux2;
      elsif C < Aux2
            then
         Maxi:= Aux1;
         Median:= Aux2;
         Mini:= C;
      else
         Maxi:= Aux1;
         Median:= C;
         Mini:= Aux2;
      end if;
   end Trier;

   -- Autre solution :
   -- Maxi:= Maximum(Maximum(A, B), C);
   -- Mini:= Minimum(Minimum(A, B), C);
   -- if A/= Maxi and A/=Mini
   -- then Median:= A;
   -- elsif B/= Maxi and B/= Mini
   -- then Median:= B;
   -- else Median:= C;
   -- end if;
end P_Entier;
