-- Paquetage P_INDICE
-- Fichier : p_indice.ads 
-- Auteur : P. SEBILO
-- Date : 30.5.96
-- Derniere mise a jour : 15.10.2002 

-- Definition de la contrainte d'indice des vecteurs contraints
--   declares dans le paquetage P_VECTEUR.

with P_Entier;
use P_Entier;

package P_Indice is

   Premier : constant T_Entier := + 5;  
   Dernier : constant T_Entier := + 9;  

   subtype T_Indice is T_Entier range Premier..Dernier;

   procedure Lire (
         L_Invite : in     String   := "Indice"; 
         I        :    out T_Indice              ); 
   -- Lecture controle

   -- Remarques : 

   -- Les valeurs PREMIER et DERNIER sont arbitraires.
   -- On aura toujours Dernier > Premier
   --   ( Vecteurs constitus d'au moins 2 lments).
   --   Les problmes lis aux vecteurs vides et et aux vecteurs
   --     constitus d'un seul lment seront envisags plus tard.

   -- On pourra gnraliser plus tard le type T_INDICE 
   --   en rendant le paquetage 'GENERIQUE'.

   subtype T_Rang is T_Positif range 1..1+(Dernier-Premier);

   function To_Rang (
         I : in     T_Indice ) 
     return T_Rang; 

   function To_Indice (
         R : in     T_Rang ) 
     return T_Indice; 

end P_Indice;
