-- Paquetage de gestion du type numeratif T_JOUR 
-- Fichier : p_jour.adb 
-- Auteur : P. SEBILO
-- Date : 2.4.96
-- Dernire mise a jour : 9.10.2001 

with P_E_Sortie;

package body P_Jour is

   procedure Lire (
         L_Invite : in     String; 
         Le_Jour  :    out T_Jour  ) is 
      Chaine : String (1 .. T_Jour'Width);  
   begin
      loop
         begin
            P_E_Sortie.Ecrire(L_Invite);
            P_E_Sortie.Lire(Chaine);
            Le_Jour:= T_Jour'Value(Chaine);
            exit;
         exception
            when others =>
               null;
         end;
      end loop;
   end Lire;

   procedure Ecrire (
         Le_Jour : in     T_Jour ) is 
   begin
      P_E_Sortie.Ecrire(T_Jour'Image(Le_Jour));
   end Ecrire;

   function Demain (
         Le_Jour : in     T_Jour ) 
     return T_Jour is 
   begin
      if Le_Jour = T_Jour'Last
            then
         return T_Jour'First;
      else
         return T_Jour'Succ(Le_Jour);
      end if;
   end Demain;

   -- Autre version qui utilise une exception
   -- function DEMAIN(LE_JOUR: in T_JOUR) return T_JOUR is
   -- begin
   --    return T_JOUR'SUCC(LE_JOUR);
   -- exception
   --    when others => return T_JOUR'FIRST;
   -- end DEMAIN;

   function Hier (
         Le_Jour : in     T_Jour ) 
     return T_Jour is 
   begin
      if Le_Jour = T_Jour'First
            then
         return T_Jour'Last;
      else
         return T_Jour'Pred(Le_Jour);
      end if;
   end Hier;

   function Est_Jour_Travail (
         Le_Jour : in     T_Jour ) 
     return Boolean is 
   begin
      return Le_Jour in T_Jour_Travail;
   end Est_Jour_Travail;

   function Est_Jour_Repos (
         Le_Jour : in     T_Jour ) 
     return Boolean is 
   begin
      return Le_Jour in T_Jour_Repos;
   end Est_Jour_Repos;

   function Est_Jour_Valide (
         La_Chaine : in     String ) 
     return Boolean is 
      Local : T_Jour;  
   begin
      Local:= T_Jour'Value(La_Chaine);
      return True;
   exception
      when others =>
         return False;
   end Est_Jour_Valide;

end P_Jour;