-- Paquetage de gestion du type numeratif T_JOUR 
-- Fichier : p_jour.ads 
-- Auteur : P. SEBILO
-- Date : 2.4.96
-- Dernire mise a jour : 14.5.98 

package P_Jour is

   type T_Jour is 
         (Lundi,    
          Mardi,    
          Mercredi, 
          Jeudi,    
          Vendredi, 
          Samedi,   
          Dimanche); 

   subtype T_Jour_Travail is T_Jour range Lundi..Vendredi;
   subtype T_Jour_Repos   is T_Jour range Samedi..Dimanche;

   procedure Lire (
         L_Invite : in     String; 
         Le_Jour  :    out T_Jour  ); 
   -- lecture controle avec rptition de l'invite en cas d'erreur.   

   procedure Ecrire (
         Le_Jour : in     T_Jour ); 

   function Demain (
         Le_Jour : in     T_Jour ) 
     return T_Jour; 
   -- DIMANCHE est suivi de LUNDI

   function Hier (
         Le_Jour : in     T_Jour ) 
     return T_Jour; 
   -- LUNDI est prcde de DIMANCHE

   function Est_Jour_Travail (
         Le_Jour : in     T_Jour ) 
     return Boolean; 

   function Est_Jour_Repos (
         Le_Jour : in     T_Jour ) 
     return Boolean; 

   function Est_Jour_Valide (
         La_Chaine : in     String ) 
     return Boolean; 
   -- Fonction vraie si LA_CHAINE contient un lment du type T_JOUR.

end P_Jour;