-- Paquetage P_VECTEUR
-- Fichier p_vecteur.adb 
-- Auteur: P. SEBILO
-- Date: 3.5.96
-- Derniere mise a jour : 16.10.2001 

with P_E_Sortie;
use P_E_Sortie;

package body P_Vecteur is

   --------------------------------------------------------------------- LIRE  

   procedure Lire (
         Identificateur : in     String    := ""; 
         V              :    out T_Vecteur        ) is 
   begin
      for I in V'range
            loop
         P_Entier.Lire
            (Identificateur & "(" & T_Indice'Image(I) & " ): ",V(I));
      end loop;
   end Lire;

   ------------------------------------------------------------------- ECRIRE  

   procedure Ecrire (
         Identificateur : in     String    := ""; 
         V              : in     T_Vecteur        ) is 
   begin
      for I in V'range
            loop
         P_E_Sortie.Ecrire
            (Identificateur & "(" & T_Indice'Image(I) & " ): ");
         P_Entier.Ecrire((V(I)));
         A_La_Ligne;
      end loop;
   end Ecrire;

   ---------------------------------------------------------------- GET / SET  

   function Get (
         V : in     T_Vecteur; 
         R : in     T_Rang     ) 
     return T_Entier is 
   begin
      return V(To_Indice(R));
   end Get;

   procedure Set (
         V : in out T_Vecteur; 
         R : in     T_Rang;    
         E : in     T_Entier   ) is 
   begin
      V(To_Indice(R)):= E;
   end Set;

   ---------------------------------------------------------------------- "+"  

   function "+" (
         V1,                   
         V2 : in     T_Vecteur ) 
     return T_Vecteur is 
      V : T_Vecteur;  
   begin
      for K in V'range
            loop
         V(K):= V1(K) + V2(K);
      end loop;
      return V;
   end "+";

   ------------------------------------------------------------- "-" (unaire)  

   function "-" (
         V : in     T_Vecteur ) 
     return T_Vecteur is 
      A : T_Vecteur;  
   begin
      for I in A'range
            loop
         A(I):= -V(I);
      end loop;
      return A;
   end "-";

   ------------------------------------------------------------ "-" (binaire)  

   function "-" (
         V1,                   
         V2 : in     T_Vecteur ) 
     return T_Vecteur is 
   begin
      return V1 + (- V2);
   end "-";

   ---------------------------------------------------------------------- "*"  

   function "*" (
         V1,                   
         V2 : in     T_Vecteur ) 
     return T_Vecteur is 
      V : T_Vecteur;  
   begin
      for K in V'range
            loop
         V(K):= V1(K) * V2(K);
      end loop;
      return V;
   end "*";

   function "*" (
         V1,                   
         V2 : in     T_Vecteur ) 
     return T_Entier is 
   begin
      return Somme(V1*V2);
   end "*";

   -------------------------------------------------------------------- SOMME

   function Somme (
         V : in     T_Vecteur ) 
     return T_Entier is 
      S : T_Entier := 0;  
   begin
      for I in V'range
            loop
         S:= S + V(I);
      end loop;
      return S;
   end Somme;

   ------------------------------------------------------------------ MOYENNE  

   function Moyenne (
         V : in     T_Vecteur ) 
     return T_Entier is 
   begin
      return Somme(V) / V'Length;
   end Moyenne;

   function Moyenne (
         V : in     T_Vecteur ) 
     return Float is 
   begin
      return Float(Somme(V)) / Float(V'Length);
   end Moyenne;

   ------------------------------------------------------------------ MINIMUM  

   function Minimum (
         V : in     T_Vecteur ) 
     return T_Entier is 
      Local : T_Entier := T_Entier'Last;  
   begin
      for I in T_Indice
            loop
         Local:= Minimum(Local, V(I));
      end loop;
      return Local;
   end Minimum;

   ------------------------------------------------------------------ MAXIMUM  

   function Maximum (
         V : in     T_Vecteur ) 
     return T_Entier is 
      Local : T_Entier := T_Entier'First;  
   begin
      for I in T_Indice
            loop
         Local:= Maximum(Local, V(I));
      end loop;
      return Local;
   end Maximum;

end P_Vecteur;
