-- Test Partiel du paquetage P_VECTEUR ( Version Ecran)
-- Gestion du type T_VECTEUR
-- Fichier tst_vecteur.adb 
-- Auteur : P. SEBILO
-- Ecrit le 22.5.98
-- Derniere mise a jour le 16.10.2002 

with Text_Io;
use Text_Io;

with P_Indice;
use P_Indice;
with P_Vecteur;
use P_Vecteur;
with P_Entier;
use P_Entier;

procedure Tst_Vecteur is 

   I1   : T_Indice;  
   Vec1,  
   Vec2 : T_Vecteur;  

   procedure Visu (
         Identificateur : in     String;   
         V              : in     T_Vecteur ) is 
   begin
      Put(Identificateur & "=(");
      for I in V'First..V'Last-1
            loop
         Put(T_Entier'Image(V(I)) & ',');
      end loop;
      Put_Line(T_Entier'Image(V(V'Last)) & ')');
   end Visu;

begin

   New_Line(2);
   Put_Line("Test Partiel du paquetage P_VECTEUR");
   Put_Line("     Gestion du type T_VECTEUR");
   New_Line;

   Put_Line("Lecture du premier Vecteur");
   Lire("VEC1", Vec1);
   New_Line;

   Put_Line("Lecture du deuxieme Vecteur");
   Lire("VEC2", Vec2);
   New_Line;

   New_Line;
   Visu("VEC1", Vec1);
   Visu("VEC2", Vec2);
   New_Line(2);

   -- Test de la lecture de l'indice
   P_Indice.Lire("Saisir l'indice de VEC1", I1);
   -- Remarque : on est oblig de prfixer car T_Indice est 
   --    un sous type de T_Entier et donc, les procedures
   --    lire de P_Indice et P_Entier ont le mme profil.

   Put_Line("Valeur = " & T_Entier'Image(Vec1(I1)));
   New_Line;

   Visu("VEC1+VEC2", Vec1+Vec2);
   Visu("-VEC1", -Vec1);
   Visu("VEC1-VEC2", Vec1-Vec2);
   Visu("VEC1*VEC2", Vec1*Vec2);
   New_Line;

   Put_Line("Produit Scalaire(VEC1*VEC2)=" & T_Entier'Image(Vec1*Vec2));
   Put_Line("Somme(VEC1)=" & T_Entier'Image(Somme(Vec1)));
   Put_Line("Moyenne(VEC1)=" & T_Entier'Image(Moyenne(Vec1)));
   Put_Line("Moyenne(VEC1)=" & Float'Image(Moyenne(Vec1)));

   Put_Line("Minimum(VEC1)=" & T_Entier'Image(Minimum(Vec1)));
   Put_Line("Maximum(VEC1)=" & T_Entier'Image(Maximum(Vec1)));
   New_Line;

end Tst_Vecteur;
