-- Test du paquetage P_VECTEUR
-- Gestion du type T_VECTEUR
-- Fichier vecteur.adb 
-- Ecrit le 28.6.93
-- Derniere mise a jour le 16.10.2001 

with Text_Io;
use Text_Io;
with Ada.Exceptions;
use Ada.Exceptions;

with P_Vecteur;
use P_Vecteur;
with P_Entier;
use P_Entier;

procedure Vecteur is 

   subtype T_Entier is P_Entier.T_Entier;

   package Entier_Io is new Text_Io.Integer_Io(T_Entier);
   use Entier_Io;

   package Reel_Io is new Text_Io.Float_Io(Float);
   use Reel_Io;

   Fich_Out : File_Type;  

   Vecteur_0  : T_Vecteur := (0, 0, 0, 0, 0);  
   Vecteur_1  : T_Vecteur := (1, 1, 1, 1, 1);  
   Vecteur_2  : T_Vecteur := (1, 4, 1, 2, 1);  
   Vecteur_3  : T_Vecteur := (1, 2, 3, 4, 4);  
   Vecteur_4  : T_Vecteur := (6, 4, 2, 1, 0);  
   Vecteur_5  : T_Vecteur := (6, - 4, 2, 1, 0);  
   Vecteur_31 : T_Vecteur := (3, 2, 3, 4, 5);  
   Vecteur_32 : T_Vecteur := (1, 2, 3, 4, 1);  

   Vecteur_Maxi : T_Vecteur := (others => T_Entier'Last);  
   Vecteur_Mini : T_Vecteur := (others => T_Entier'First);  

   procedure Ecriture (
         Identificateur : in     String;   
         V              : in     T_Vecteur ) is 
      -- Ecriture sur FICH_OUT
   begin
      Put(Fich_Out, Identificateur);
      for I in V'range
            loop
         Put(Fich_Out, T_Entier'Image(V(I)));
         Put(Fich_Out, " ");
      end loop;
      New_Line(Fich_Out);
   end Ecriture;

begin

   New_Line(2);
   Put_Line("Test du paquetage P_VECTEUR");
   Put_Line("     Gestion du type T_VECTEUR");
   New_Line;

   Put_Line("Fichier des resultats : VECTEUR.OUT");
   Create(Fich_Out, Out_File, "VECTEUR.OUT");
   Put_Line("Comparez vos resultats avec l'oracle : fichier VECTEUR.ORA");
   New_Line;

   Put_Line(Fich_Out,"                             Fichier VECTEUR.OUT");
   Put_Line(Fich_Out,"                             *******************");
   New_Line(Fich_Out, 3);



   New_Line(Fich_Out);
   Put_Line(Fich_Out,
      "* function GET(V: in T_VECTEUR; R: in T_RANG) return T_ENTIER");
   Put_Line(Fich_Out, "           ---");
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_3);
   Put_Line(Fich_Out, " R=1   =>  " & T_Entier'Image(Get(Vecteur_3, 1)));
   Put_Line(Fich_Out, " R=3   =>  " & T_Entier'Image(Get(Vecteur_3, 3)));
   New_Line(Fich_Out);


   New_Line(Fich_Out);
   Put_Line(Fich_Out,
      "* procedure SET(V: in T_VECTEUR; R: in T_RANG; E: in T_ENTIER)");
   Put_Line(Fich_Out, "            ---");
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_3);
   Put_Line(Fich_Out, "  R=1,  E=111  ==>");
   Set(Vecteur_3, 1, 111);
   Ecriture("V=", Vecteur_3);
   New_Line(Fich_Out);


   New_Line(Fich_Out);
   Put_Line(Fich_Out,
      "* function '+'(V1, V2: in T_VECTEUR) return T_VECTEUR");
   Put_Line(Fich_Out, "           ---");
   New_Line(Fich_Out);

   Ecriture("V1=", Vecteur_1);
   Ecriture("V2=", Vecteur_2);
   Put_Line(Fich_Out, "   =>");
   Ecriture("'+'=", Vecteur_1 + Vecteur_2);
   New_Line(Fich_Out);


   Put_Line(Fich_Out, "* function '-'(V: in T_VECTEUR) return T_VECTEUR");
   Put_Line(Fich_Out, "           ---");
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_2);
   Put_Line(Fich_Out, "   =>");
   Ecriture("'-'=", - Vecteur_2);
   New_Line(Fich_Out);


   New_Line(Fich_Out);
   Put_Line(Fich_Out,
      "* function '-'(V1, V2: in T_VECTEUR) return T_VECTEUR");
   Put_Line(Fich_Out, "           ---");
   New_Line(Fich_Out);

   Ecriture("V1=", Vecteur_1);
   Ecriture("V2=", Vecteur_2);
   Put_Line(Fich_Out, "   =>");
   Ecriture("'-'=", Vecteur_1 - Vecteur_2);
   New_Line(Fich_Out);


   New_Line(Fich_Out);
   Put_Line(Fich_Out,
      "* function '*'(V1, V2: in T_VECTEUR) return T_VECTEUR");
   Put_Line(Fich_Out, "           ---");
   New_Line(Fich_Out);

   Ecriture("V1=", Vecteur_1);
   Ecriture("V2=", Vecteur_2);
   Put_Line(Fich_Out, "   =>");
   Ecriture("'*'=", Vecteur_1 * Vecteur_2);
   New_Line(Fich_Out);


   New_Line(Fich_Out);
   Put_Line(Fich_Out,
      "* function '*'(V1, V2: in T_VECTEUR) return T_ENTIER");
   Put_Line(Fich_Out, "           ---");
   New_Line(Fich_Out);

   Ecriture("V1=", Vecteur_0);
   Ecriture("V2=", Vecteur_2);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "'*'=" & T_Entier'Image(Vecteur_0 * Vecteur_2));
   New_Line(Fich_Out);

   Ecriture("V1=", Vecteur_2);
   Ecriture("V2=", Vecteur_3);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "'*'=" & T_Entier'Image(Vecteur_2 * Vecteur_3));
   New_Line(Fich_Out);


   New_Line(Fich_Out);
   Put_Line(Fich_Out, "* function SOMME(V: in T_VECTEUR) return T_VECTEUR");
   Put_Line(Fich_Out, "           -----");
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_0);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "SOMME=" & T_Entier'Image(Somme(Vecteur_0)));
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_1);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "SOMME=" & T_Entier'Image(Somme(Vecteur_1)));
   New_Line(Fich_Out);


   New_Line(Fich_Out);
   Put_Line(Fich_Out,
      "* function MOYENNE(V: in T_VECTEUR) return T_ENTIER");
   Put_Line(Fich_Out, "           -------");
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_2);
   Put_Line(Fich_Out, "   =>");
   Put(Fich_Out, "MOYENNE=" & T_Entier'Image(Moyenne(Vecteur_2)));
   New_Line(Fich_Out);

   New_Line(Fich_Out);
   Put_Line(Fich_Out, "* function MOYENNE(V: in T_VECTEUR) return FLOAT");
   Put_Line(Fich_Out, "           -------");
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_2);
   Put_Line(Fich_Out, "   =>");
   Put(Fich_Out, "MOYENNE=");
   Reel_Io.Put(Fich_Out, Moyenne(Vecteur_2), 5, 2, 0);
   New_Line(Fich_Out);

   New_Line(Fich_Out);
   Put_Line(Fich_Out,
      "* function MINIMUM(V: in T_VECTEUR) return T_VECTEUR");
   Put_Line(Fich_Out, "           -------");
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_0);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MINIMUM=" & T_Entier'Image(Minimum(Vecteur_0)));
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_2);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MINIMUM=" & T_Entier'Image(Minimum(Vecteur_2)));
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_3);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MINIMUM=" & T_Entier'Image(Minimum(Vecteur_3)));
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_4);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MINIMUM=" & T_Entier'Image(Minimum(Vecteur_4)));
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_Mini);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MINIMUM=" & T_Entier'Image(Minimum(Vecteur_Mini)));
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_Maxi);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MINIMUM=" & T_Entier'Image(Minimum(Vecteur_Maxi)));
   New_Line(Fich_Out);

   New_Line(Fich_Out);
   Put_Line(Fich_Out,
      "* function MAXIMUM(V: in T_VECTEUR) return T_VECTEUR");
   Put_Line(Fich_Out, "           -------");
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_0);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MAXIMUM=" & T_Entier'Image(Maximum(Vecteur_0)));
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_2);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MAXIMUM=" & T_Entier'Image(Maximum(Vecteur_2)));
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_3);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MAXIMUM=" & T_Entier'Image(Maximum(Vecteur_3)));
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_4);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MAXIMUM=" & T_Entier'Image(Maximum(Vecteur_4)));
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_Mini);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MAXIMUM=" & T_Entier'Image(Maximum(Vecteur_Mini)));
   New_Line(Fich_Out);

   Ecriture("V=", Vecteur_Maxi);
   Put_Line(Fich_Out, "   =>");
   Put_Line(Fich_Out, "MAXIMUM=" & T_Entier'Image(Maximum(Vecteur_Maxi)));
   New_Line(Fich_Out);

   Close(Fich_Out);

end Vecteur;
